program cwPing;

{$APPTYPE CONSOLE}

uses
  Windows,
  SysUtils,
  IdIcmpClient;

var
  VDelayTime : LongInt;
  VLost      : Boolean;

begin
  if (ParamCount > 0) then
  begin
    with TIdIcmpClient.Create(nil) do
    begin
//      try
        Host           := ParamStr(1);
        Port           := 1111;
        ReceiveTimeout := StrToIntDef(ParamStr(2), 500);
        VDelayTime     := StrToIntDef(ParamStr(3), 1000);

        WriteLn('Pinging ' + Host + ' [Timeout: ' + IntToStr(ReceiveTimeout) + 'ms] [Delay: ' + IntToStr(VDelayTime) + 'ms]');
        WriteLn('');

//        try
          VLost := false;
          while true do
          begin
            Ping;
            Write('Ping ');
            if (ReplyStatus.ReplyStatusType = rsEcho) then
            begin
              if VLost then
              begin
                VLost := false;
                Windows.Beep(1100, 150);
              end;
              WriteLn('answered! ' + ReplyStatus.FromIpAddress + ' [' + IntToStr(ReplyStatus.MsRoundTripTime) + 'ms]');
              Sleep(VDelayTime);
            end
            else
            begin
              VLost := true;
              WriteLn('lost?');
              Windows.Beep(1000, 150);
            end;
          end;
//        except
          WriteLn('');
          WriteLn('Error occured [' + DateTimeToStr(Now) + ']');

          while true do
          begin
            Windows.Beep(1100, 150);
            Sleep(100);
            Windows.Beep(1000, 150);
            Sleep(100);
//          end;
        end;
//      finally
        Free;
//      end;
    end;
  end
  else
    WriteLn(ExtractFileName(ParamStr(0)) + ' [hostname] [timeout in ms] [delaytime in ms]');
end.
